<%
response.setHeader("Cache-Control","no-store"); //HTTP 1.1
response.setHeader("Pragma","no-cache"); //HTTP 1.0
response.setDateHeader ("Expires", 0); //prevents caching at the proxy server
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%------------------------------------------------------------------------------
 - Licensed Materials - Property of IBM
 - 
 - (C) Copyright IBM Corporation 2006. All Rights Reserved.
 - Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure
 - restricted by GSA ADP  Schedule Contract with IBM Corp.
  -----------------------------------------------------------------------------%>
<%--
 -  $$RCSfile: createReview.jsp,v $$
 -  $$Revision: 1.108 $$  $$Date: 2007/09/17 18:34:45 $$
 --%>  
  
<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>
<%@ taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://www.ibm.com/ram/repository/tags" prefix="ram"%>
<%@ page language="java" contentType="text/html; charset=utf-8" pageEncoding="utf-8" %>
<%@ page import="java.util.ResourceBundle" %>
<html>
<head>
	<%@include file="/theme/metaHeader.jspf"%>
	<meta http-equiv="Pragma" content="no-cache">
	<%@include file="/theme/cssHideRightColumn.jspf"%>
	<script src="${pageContext.request.contextPath}/${applicationScope.javascriptPath}/js/lifecycle_visualization.js"></script>
	<script src="${pageContext.request.contextPath}/${applicationScope.javascriptPath}/js/categorize_tree.js"></script>
	<script src="${pageContext.request.contextPath}/${applicationScope.javascriptPath}/ckeditor/ckeditor.js"></script>
	
	<% String actualLocale = ResourceBundle.getBundle("com.ibm.ram.repository.web.bundles.webMessages", request.getLocale()).getLocale().toString().replace('_', '-'); %>
	
	<link rel="csh" href="${applicationScope.cshPath}">
	<title>${bundle.adminTitle}</title>
	
	
	
	<%-- Dojo layer imports  --%>
	${pc_MasterLifecycleEditor.JSLayers['ram/layers/LifecycleEditor']}
	
	<script type="text/javascript">
		dojo.require("dojo.parser");
		dojo.require("ram.RamDialog");
		dojo.require("dijit.form.Button");
		dojo.require("dijit.Menu");
		dojo.require("dijit.form.NumberSpinner");
		dojo.require("dijit.layout.ContentPane");
		dojo.require("dijit.layout.BorderContainer");
		dojo.require("dijit.Editor");
	    dojo.require("dijit.TitlePane");
	    dojo.require("dijit._editor.plugins.TextColor");
	    dojo.require("dijit._editor.plugins.LinkDialog");
		dojo.require("ram.ConditionBuilder");
		dojo.require("ram.categorytree.CategoryTree");
//		dojo.registerModulePath("ram", "../ram");
		dojo.requireLocalization("ram", "lifecycleeditor");
		function setHiddenField(field, hide) {
			document.getElementById(field).value = hide;
		}
		
		var currentWindowHeight;
		var currentEditorHeight;
		function resizeEditor() {

			if(/msie|MSIE 6/.test(navigator.userAgent)) {
				var windowHeight = document.body.clientHeight;
				var editorScrollHeight = document.getElementById('editor').scrollHeight;
				if(currentEditorHeight != windowHeight) {
					windowHeight-=300;
					var split = dijit.byId('borderContainer');
					if (typeof(split)=="undefined") {
						return;
					}
					var splitWidth = '100%';
					var editorScrollHeight = document.getElementById('editor').scrollHeight;
					if(editorScrollHeight+80 > windowHeight) {
						windowHeight = editorScrollHeight + 100;
					}
					split.resize({w:splitWidth,h:windowHeight,l:0,t:0})
					document.lifecycleApplet.height = windowHeight-25;
				}
				currentEditorHeight = document.documentElement.clientHeight;
			} else {
				var windowHeight = document.body.clientHeight;
				var editorScrollHeight = document.getElementById('editor').scrollHeight;
				if(currentWindowHeight != windowHeight || currentEditorHeight != editorScrollHeight) {
					if (navigator.appName.indexOf("Microsoft") == -1) {
						windowHeight-=240;
					} else {
						windowHeight-=300; 
					}
					if(editorScrollHeight+80 > windowHeight) {
						windowHeight = editorScrollHeight + 100;
					}
					var split = dijit.byId('borderContainer');
					if(split != null) {
						var splitWidth = '100%';
						split.resize({w:splitWidth,h:windowHeight,l:0,t:0});
					} 
					document.lifecycleApplet.height = windowHeight-25;
				}
				currentWindowHeight = document.body.clientHeight;
				currentEditorHeight = editorScrollHeight;
			}
		}

		function showApplet() {
			document.getElementById('diagram').style.display = 'inline';
			resizeEditor();
			if(!isLifecycleEditorInitialized()) {
				initialize();
			}
		}

		var diagramWidth;

		function storeWidth() {
			diagramWidth = document.getElementById('diagramPane').offsetWidth;
		}

		function centerDiagram() {
			//if(diagramWidth != document.getElementById('diagramPane').offsetWidth) {
			//	centerLifecycleDiagram();
			//}
		}
				
	</script>
	
	<script src="${pageContext.request.contextPath}/${applicationScope.javascriptPath}/js/lifecycle_editor.js"></script>
	
	<script type="text/javascript">
		isMasterLifecycle = true;
		dojo.addOnLoad(function(){
			fetchAttributeData();
		});
	</script>
</head>
<f:view>
	<body class="ram"  onResize="resizeEditor()" onLoad="showApplet()">
	<style>
	 	.dijitSplitterCover{
 			opacity:0;
		} 
		#borderContainer {
    		width: 100%;
    		height: 600px;
  		}
		.diagramBorder {
			border: 1px solid #ccc;
		}
		
		select.result {
			width: 100%;
		}
		
		.workflowElementDescription {
			color: #67555C;
		}
		td.checkboxColumn {
			text-align: center;
		}
		td.nowrapCell {
			white-space: nowrap;
		}
		
		#workflowElements {
			margin-right: 5px;
		}
		.state-configs {
			margin: 10px 0;
		}
		.radio_option {
			margin: 5px 0;
		}
		#override_permissions, #no_override_permissions, #readonly_permissions {
			margin: 5px 0px 0;
		}
		
		.buttons-bar {
			margin: 10px 0;
		}
		
		.buttons-bar input.commandExButton {
			margin-right: 5px;
		}
		
		#voting_restart {
			margin-top: 10px;
		}
		
		.editor-section {
			margin: 10px 0 40px;
		}
		
		.secondaryActionGroup {
			margin-bottom: 0px;
		}
		
		.primarySectionContent {
			margin: 5px;
		}
		
		.radio {
			margin: 0 5px 0 0;
		}
	</style>

	<hx:scriptCollector id="scriptCollector1">
	
		<%@ include file="/theme/header.jspf" %>
			<div id="waitingPanel" style="display:none;">
				<h:panelGroup id="loading_tab_animation" style="text-align:center;">		
					<h:graphicImage id="animatedBusyIcon" 
							value="/theme/images/icon_animated_busy.gif" alt="#{bundle.alt_loading_icon}"/>		
				</h:panelGroup>
				<td>Loading...</td>
			</div>
			<ram:form id="mainForm">
				<div id="contentColumn">
				<div class="inside">
					<div id="top-buttons" class="primaryActionGroup_float_top">
						<input type="button" class="commandExButton" onclick="event_saveLifecycle(false);" value="${bundle.button_save}" />
						<input type="button" class="commandExButton" onclick="event_saveLifecycle(true);" value="${bundle.button_save_and_finish}" />
						<input type="button" class="commandExButton" onclick="event_cancelEditorChanges();" value="${bundle.button_cancel}" />
					</div>
					
					<h:graphicImage  id="lifecycleImg" value="/theme/images/lifecycle_ed_40.png" style="float: left; margin-right:10px;" />
					<h1>
						<h:outputText id="pageTitle" value="#{bundle.page_title_master_lifecycle}" />
						
						<ram:infopop id="pageHelp" styleClass="pageHelp" image="/theme/images/icons/obj16/info_indicator.gif" 
							contextId="aclc0110"/>
					</h1>
					<div style="clear:both;"></div>
					<%-- Hidden  Lifecycle ID to be picked up by the javascript--%>
					<h:inputHidden value="#{pc_MasterLifecycleEditor.lifecycleId}" id="lifecycleId" />
					<div id="splitWrapper" style="position: relative; width: 100%; border-top: 1px dotted #D8D8D8;  padding-top: 2px;" onmouseup="centerDiagram()" onmousedown="storeWidth()">
					<div dojoType="dijit.layout.BorderContainer" design="sidebar" gutters="true" liveSplitters="true" id="borderContainer">
						
						<div id="diagramPane" dojoType="dijit.layout.ContentPane" splitter="true" region="leading" style="width: 150px; overflow: hidden; border: 1px solid #D8D8D8;">
							<div id="diagram" style="display: none;">
						        <ram:lifecycleVisualization id="lifecycleVisualization" editable="true" value="#{pc_MasterLifecycleEditor.visualLifecycle}"></ram:lifecycleVisualization>
						    </div>
					  	</div>
					   
					  	<div dojoType="dijit.layout.ContentPane" splitter="true" region="center" onclick="resizeEditor();">
							<div id="editor" style="padding: 10px 8px 10px 8px;">
						    
						    	<div id="editor_nav">
						    		<h:outputText id="instructLifecycleConfig" value="#{bundle.help_lifecycle_section_configuration}" styleClass="sectionInstructions"/>
						    		<table border="0" cellspacing="0">
						    			<tr style="background-color: #eee">
						    				<td class="panelFormBox_Label-Cell nowrapCell">
						    					<label class="label" for="workflowElements">
						    						<ram:infopop id="configurationHelp" text="#{bundle.label_lifecycle_nav}" styleClass="jazz-app-ua-TextHoverHelp" />
						    					</label>
						    				</td>
						    				<td width="100%">
						    					<select id="workflowElements"></select>
						    					<input type="button" onclick="event_selectWorkflowElement();" value="${bundle.button_go}"/>
						    					<span id="private_state_config" style="display: none;">
								        			<input style="vertical-align: middle; margin-left: 20px;" id="private_state_config_checkbox" type="checkbox" onclick="setPrivateCollaboration(this);"/>
								        			<img style="vertical-align: text-top;" src="<%=request.getContextPath() +  "/theme/images/icons/obj16/statusLocked.gif"%>"/>
								        			<ram:textHoverHelp id="private_state_config_checkbox_label" value="#{bundle.label_lifecycle_private_collaboration}" helpContentString="#{bundle.help_lifecycle_private_review}" />
								        			<span id="private_state_config_checkbox_inherited_text" class="inherited" style="margin-left: 5px; display: none;">
							        					(<ram:textHoverHelp id="private_state_config_checkbox_inherited_text_hover" 
							        						value="#{bundle.label_inherited}" helpContentString="#{bundle.help_lifecycle_inherited}"/>)
						        					</span>
							        			</span>
						    				</td>
						    			</tr>
						    			<tr>
						    				<td></td>
						    				<td><div id="workflowElementDescription" class="workflowElementDescription" style="display: none;"></div></td>
						    			</tr>
						    			<tr>
						    				<td></td>
						    				<td><div id="aligned-configs"></div></td>
						    			</tr>
						    		</table>
						    	</div>
						    	
						    	<div id="lifecycle">
						    		<table class="panelFormBox" border="0" style="margin: 10px 0;">
						    			<tr>
						    				<td class="panelFormBox_Label-Cell">
						    					<label for="lifecycleName" for="lifecycleName">${bundle.label_name}</label>
						    				</td>
						    				<td>
						    					<input id="lifecycleName" value="" onblur="lifecycleNameFieldChanged(this);" class="longField">
						    				</td>
						    			</tr>
						    			<tr>
						    				<td class="panelFormBox_Label-Cell">
						    					<label for="lifecycleDescription">${bundle.label_description}</label>
						    				</td>
						    				<td>
						    					<textarea rows="5" id="lifecycleDescription" value="" onblur="lifecycleDescriptionFieldChanged(this);" class="longField"></textarea>
						    				</td>
						    			</tr>
						    			<tr>
						    				<td class="panelFormBox_Label-Cell">
						    				</td>
						    				<td>
						    					<input type="checkbox" id="lifecycleComment" class="checkboxText" onclick="lifecycleCommentFieldChanged(this);"/> 
						    					<label class="checkboxText" for="lifecycleComment">${bundle.label_comments_desc}</label>
						    				</td>
						    			</tr>
						    		</table>
						    		
						    		<div id="add_lifecycle_configs"></div>	  
						    		<div id="lifecycle_conditions" class="editor-section"></div>
						    		<div id="review_board" class="editor-section"></div>
						    		<div id="collaborators" class="editor-section"></div>
						    		<div id="community_scoping" class="editor-section"></div>
						    	</div>
						    	<div id="state" style="display:none">
						    		<div id="state_advanced" class="editor-section" style="display:none"></div>
						        	<div id="state_users" class="editor-section" style="display:none"></div>
							        <div id="policy_state_config" class="editor-section" style="display:none"></div>
								</div>
								<div id="transition" style="display: none">
									<div id="add_transition_configs"></div>
									<div id="transition_conditions" class="editor-section"></div>
								</div>
								<div id="loading_editor" style="display: none; text-align: center; margin: 100px 0;">
									<img src="<%=request.getContextPath() +  "/theme/images/icon_animated_busy.gif"%>" alt="#{bundle.alt_loading_icon}"/>
									<span style="margin-left: 5px;">#{bundle.alt_loading_icon}</span>
								</div>
						    </div>
						    <div style="clear: both;"></div>
						    <div id="bottom-buttons" class="primaryActionGroup">
								<input type="button" class="commandExButton" onclick="event_saveLifecycle(false);" value="${bundle.button_save}" />
								<input type="button" class="commandExButton" onclick="event_saveLifecycle(true);" value="${bundle.button_save_and_finish}" />
								<input type="button" class="commandExButton" onclick="event_cancelEditorChanges();" value="${bundle.button_cancel}" />
							</div>
						</div>
					</div>
					<h:inputHidden value="#{pc_MasterLifecycleEditor.workflowId}" id="workflowId" />
					<h:inputHidden value="#{pc_UserSearchDialog.showSearchScopeOption}" id="searchLDAP" />
					</div>
					    
				</div>
				</div>
			</ram:form>		
	<%@include file="/theme/footer.jspf"%>
	
	</hx:scriptCollector>
	</body>
</f:view>
</html>